/*******************************************************************************
 * FoxWeapon_RepairGunBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_RepairGunBase extends FoxWeapon_TargetBase
    native(Weapon)
    config(Weapon)
    hidecategories(Navigation);

var const class<DamageType> EnemyDamageType;
var const class<DamageType> FriendlyDamageType;
var const config float MinTimeToFullRepair;
var(Animation) WeaponAnimSet AN_StartFire;
var(Animation) WeaponAnimSet AN_EndFire;

// Export UFoxWeapon_RepairGunBase::execGetFormattedWeaponStats(FFrame&, void* const)
native function bool GetFormattedWeaponStats(out array<StatPanelEntry> StatEntries);

simulated function bool HasAmmo(byte FireModeNum, optional int Amount)
{
    Amount = 1;
    // End:0x16
    if(!bConsumeAmmo)
    {
        return true;
    }
    return super(FoxWeapon).HasAmmo(FireModeNum, Amount);
    //return ReturnValue;    
}

simulated function ConsumeAmmo(byte FireModeNum)
{
    local float RechargeTimerReducerMultiplier;

    RechargeTimerReducerMultiplier = 1.0;
    // End:0xBC
    if(FireModeNum == 0)
    {
        // End:0xBC
        if(bConsumeAmmo)
        {
            ++ AmmoUsedCount;
            ++ SimulatedAmmoUsedCount;
            AmmoLeftCount = GetAmmoLeftInMagazine();
            // End:0xBC
            if(Role == ROLE_Authority)
            {
                ClearTimer('TimerAddAmmo');
                // End:0xBC
                if(AmmoLeftCount > 0)
                {
                    SetTimer((RechargeTimer * RechargeTimerReducerMultiplier) / (GetMagazineSize()), true, 'TimerAddAmmo');
                }
            }
        }
    }
    //return;    
}

simulated function bool IsActorRepairable(Actor TheMachine)
{
    // End:0x4A
    if((FoxPawn(TheMachine) == none) || FoxPawn(TheMachine).bIsMachine == false)
    {
        return false;
    }
    return WorldInfo.GRI.OnSameTeam(Instigator, TheMachine) || (FoxPawn(TheMachine).PlayerReplicationInfo == none) && FoxPawn(TheMachine).bHealIfNoPRI;
    //return ReturnValue;    
}

simulated function bool IsRecharging()
{
    return CurrentFireMode == 1;
    //return ReturnValue;    
}

simulated function bool BeginRecharge()
{
    return false;
    //return ReturnValue;    
}

simulated function TryToGetBackToFiringState()
{
    local FoxPC FPC;

    // End:0x13A
    if(Instigator.IsHumanControlled() && BurstFireMax == 0)
    {
        FPC = FoxPC(Instigator.Controller);
        // End:0x13A
        if((((((FPC != none) && FPC.PlayerInput != none) && FPC.MyFoxInput.bHoldingFiringButton) && FPC.CanFireWeapon(self)) && FPC.CanUseWeapon()) && (IsWeaponTargetValid()) == true)
        {
            StartFire(0);
        }
    }
    //return;    
}

simulated function StartFire(byte FireModeNum)
{
    // End:0xEC
    if((Instigator != none) && Instigator.IsHumanControlled())
    {
        // End:0x5A
        if((IsWeaponTargetValid()) == true)
        {
            super(Weapon).StartFire(FireModeNum);
        }
        // End:0xEC
        else
        {
            // End:0xEC
            if(((bCanHelpInstigator == true) && FoxPawn(Instigator) != none) && FoxPawn(Instigator).Health < FoxPawn(Instigator).HealthMax)
            {
                super(Weapon).StartFire(FireModeNum);
            }
        }
    }
    //return;    
}

simulated function bool CanFireWeapon()
{
    return super(FoxWeapon).CanFireWeapon();
    //return ReturnValue;    
}

simulated function InstantFire()
{
    //return;    
}

simulated function StartRepairAnim()
{
    local float WarmupTime, BlendInTime;

    BlendInTime = GetTimerCount('WarmedDown');
    ClearTimer('WarmedDown');
    // End:0x56
    if(BlendInTime == float(-1))
    {
        BlendInTime = 0.10;
    }
    AN_StartFire.BlendInTime = BlendInTime;
    WarmupTime = PlayWeaponSet(AN_StartFire, 1.0, false, false);
    SetTimer(WarmupTime, false, 'WarmedUp');
    //return;    
}

simulated function EndRepairAnim()
{
    local float WarmDownTime, BlendInTime;

    BlendInTime = GetTimerCount('WarmedUp');
    ClearTimer('WarmedUp');
    // End:0x56
    if(BlendInTime == float(-1))
    {
        BlendInTime = 0.10;
    }
    AN_EndFire.BlendInTime = BlendInTime;
    WarmDownTime = PlayWeaponSet(AN_EndFire, 1.0, false, false);
    SetTimer(WarmDownTime, false, 'WarmedDown');
    //return;    
}

protected simulated function WarmedUp()
{
    //return;    
}

protected simulated function WarmedDown()
{
    //return;    
}

simulated function PerformReload(const int AmountToReload)
{
    //return;    
}

simulated function ProcessInstantHit(byte FiringMode, ImpactInfo Impact, optional int NumHits)
{
    local FoxPawn FP;
    local FoxDeployable_Base Deployable;
    local float DamageAmount;
    local bool bValidRepair;

    FP = FoxPawn(Impact.HitActor);
    Deployable = FoxDeployable_Base(Impact.HitActor);
    // End:0x8B
    if((FP == none) && Deployable == none)
    {
        StopRepairPoints();
        return;
    }
    // End:0x11A
    if(FP != none)
    {
        DamageAmount = (((InstantHitDamage[0] * MinTimeToFullRepair) >= float(FP.HealthMax)) ? InstantHitDamage[0] : float(FP.HealthMax) / MinTimeToFullRepair);
    }
    // End:0x197
    else
    {
        DamageAmount = (((InstantHitDamage[0] * MinTimeToFullRepair) >= float(Deployable.default.Health)) ? InstantHitDamage[0] : float(Deployable.default.Health) / MinTimeToFullRepair);
    }
    // End:0x252
    if(FoxPRI(Instigator.PlayerReplicationInfo).WeaponUsageStats != none)
    {
        FoxPRI(Instigator.PlayerReplicationInfo).WeaponUsageStats.IncrementRoundsHit(FoxPawn(Instigator).CurrentZoomState);
    }
    // End:0x2C8
    if(IsActorRepairable(FP))
    {
        bValidRepair = true;
        FP.HealDamage(int(DamageAmount), Instigator.Controller, FriendlyDamageType);
    }
    // End:0x588
    else
    {
        // End:0x463
        if(Deployable != none)
        {
            // End:0x39C
            if(WorldInfo.GRI.OnSameTeam(Instigator, Deployable.DeployablePRI))
            {
                bValidRepair = true;
                Deployable.HealDamage(int(DamageAmount * 2.0), Instigator.Controller, FriendlyDamageType);
            }
            // End:0x460
            else
            {
                Deployable.TakeDamage(int(DamageAmount * 10.0), Instigator.Controller, Impact.HitLocation, InstantHitMomentum[FiringMode] * Impact.RayDir, EnemyDamageType, Impact.HitInfo, self);
            }
        }
        // End:0x588
        else
        {
            // End:0x588
            if(!WorldInfo.GRI.OnSameTeam(Instigator, FP))
            {
                // End:0x588
                if(ShouldRegisterDamage(FP))
                {
                    FP.TakeDamage(int(DamageAmount * 0.30), Instigator.Controller, Impact.HitLocation, InstantHitMomentum[FiringMode] * Impact.RayDir, EnemyDamageType, Impact.HitInfo, self);
                }
            }
        }
    }
    // End:0x5D2
    if(FP != none)
    {
        FP.TakeDamageStartLoc = Impact.StartTrace;
    }
    // End:0x635
    if(bValidRepair && ((FP != none) && ShouldGivePointsForRepair(FP)) || Deployable != none)
    {
        // End:0x632
        if(!IsGainingRepairPoints())
        {
            StartRepairPoints();
        }
    }
    // End:0x63F
    else
    {
        StopRepairPoints();
    }
    //return;    
}

simulated function bool ShouldGivePointsForRepair(FoxPawn RepairPawn)
{
    // End:0x4D
    if(!WorldInfo.GRI.OnSameTeam(Instigator, RepairPawn))
    {
        return false;
    }
    // End:0x8D
    if((RepairPawn.PlayerReplicationInfo == none) && FoxPawn_ScorpionTank(RepairPawn) == none)
    {
        return false;
    }
    // End:0xF1
    if(((FoxPawn_ScorpionTank(RepairPawn) == none) && FoxPawn_HardSuit(RepairPawn) != none) && FoxPawn_HardSuit(RepairPawn).GetDriver() == none)
    {
        return false;
    }
    return true;
    //return ReturnValue;    
}

simulated function StartRepairPoints()
{
    SetTimer(FoxGRI(WorldInfo.GRI).GetIntervalForEvent(18), true, 'OnRepairInterval');
    //return;    
}

simulated function StopRepairPoints()
{
    ClearTimer('OnRepairInterval');
    //return;    
}

simulated function OnRepairInterval()
{
    local bool CanGetPoints;
    local int ScoreToAdd;
    local FoxPRI FPRI;

    FPRI = (((Instigator != none) && Instigator.PlayerReplicationInfo != none) ? FoxPRI(Instigator.PlayerReplicationInfo) : none);
    CanGetPoints = ((FPRI != none) ? FPRI.ExpFromRepairs < FoxGRI(WorldInfo.GRI).MaxExpFromRepairs : false);
    // End:0x27D
    if(CanGetPoints)
    {
        // End:0x1CF
        if((Instigator.IsLocallyControlled() && Instigator.Controller != none) && FoxPC(Instigator.Controller).MyFoxHud != none)
        {
            FoxPC(Instigator.Controller).MyFoxHud.AddNewPassivePointNotification(18);
        }
        // End:0x27D
        if(Role == ROLE_Authority)
        {
            ScoreToAdd = FoxGRI(WorldInfo.GRI).GetScoreForEvent(18);
            FPRI.AddExperience(ScoreToAdd);
            FPRI.ExpFromRepairs += ScoreToAdd;
        }
    }
    //return;    
}

simulated function bool IsGainingRepairPoints()
{
    return IsTimerActive('OnRepairInterval');
    //return ReturnValue;    
}

simulated state WeaponCharging
{
    simulated function BeginState(name PreviousStateName)
    {
        super(Object).BeginState(PreviousStateName);
        StartRepairAnim();
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        super(FoxWeapon).EndState(NextStateName);
        //return;        
    }

    simulated event bool IsFiring()
    {
        return true;
        //return ReturnValue;        
    }

    simulated function EndFire(byte FireModeNum)
    {
        EndRepairAnim();
        super(Weapon).EndFire(FireModeNum);
        GotoState('Active');
        //return;        
    }

    protected simulated function WarmedUp()
    {
        GotoState('WeaponFiring');
        //return;        
    }
    stop;    
}

simulated state WeaponFiring
{
    simulated event bool IsFiring()
    {
        return true;
        //return ReturnValue;        
    }

    simulated function InstantFire()
    {
        super(FoxWeapon).InstantFire();
        //return;        
    }

    simulated function EndFire(byte FireModeNum)
    {
        EndRepairAnim();
        super(Weapon).EndFire(FireModeNum);
        GotoState('Active');
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        StopRepairPoints();
        super.EndState(NextStateName);
        //return;        
    }
    stop;    
}

state Reloading
{
    simulated event BeginState(name PreviousStateName)
    {
        TimerAddAmmo();
        SetTimer(RechargeTimer / (GetMagazineSize()), true, 'TimerAddAmmo');
        super.BeginState(PreviousStateName);
        //return;        
    }

    simulated event EndState(name NextStateName)
    {
        super.EndState(NextStateName);
        //return;        
    }
    stop;    
}

defaultproperties
{
    AN_StartFire=(TP_Anim=(AnimName=(None,None,Repair_Start_A)),FP_Anim=Repair_Start_A,WP_Anim=Repair_Start_A,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.250,BlendOutTime=0.0,AbortBlendOutTime=0.10)
    AN_EndFire=(TP_Anim=(AnimName=(None,None,Repair_End_A)),FP_Anim=Repair_End_A,WP_Anim=Repair_End_A,HG_Anim=None,RateMultiplier=1.0,BlendInTime=0.10,BlendOutTime=0.0,AbortBlendOutTime=0.10)
    bCanHurtMachines=true
    bCanHelpMachines=true
    bCanHurtFleshies=true
    HelpString="Repair"
    HurtString="Shock"
    bAutomaticWeapon=true
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_RepairGunBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_RepairGunBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_RepairGunBase.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_RepairGunBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.7972960
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_RepairGunBase.LensComp'
    MuzzleLensFlare=LensComp
    AN_FullReload=(TP_Anim=(AnimName=(None,None,Overheat_A)),FP_Anim=Overheat_A,WP_Anim=Overheat_A)
    AN_NormalFire=(TP_Anim=(AnimName=(None,None,Repair_Start_A)),FP_Anim=Repair_Loop_A,WP_Anim=Repair_Loop_A)
    FiringStatesArray=/* Array type was not detected. */
    bInstantHit=true
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_RepairGunBase.WeaponMesh'
    Mesh=WeaponMesh
}